type 'a withinfo_t = { v : 'a; p : FStar_Range.range; }
val withinfo_t_to_yojson :
  ('a -> Yojson.Safe.t) -> 'a withinfo_t -> Yojson.Safe.t
val withinfo_t_of_yojson :
  (Yojson.Safe.t -> 'a Ppx_deriving_yojson_runtime.error_or) ->
  Yojson.Safe.t -> 'a withinfo_t Ppx_deriving_yojson_runtime.error_or
val pp_withinfo_t :
  (Ppx_deriving_runtime.Format.formatter -> 'a -> Ppx_deriving_runtime.unit) ->
  Ppx_deriving_runtime.Format.formatter ->
  'a withinfo_t -> Ppx_deriving_runtime.unit
val show_withinfo_t :
  (Ppx_deriving_runtime.Format.formatter -> 'a -> Ppx_deriving_runtime.unit) ->
  'a withinfo_t -> Ppx_deriving_runtime.string
val __proj__Mkwithinfo_t__item__v : 'a withinfo_t -> 'a
val __proj__Mkwithinfo_t__item__p : 'a withinfo_t -> FStar_Range.range
type var = FStar_Ident.lident withinfo_t
val var_to_yojson : var -> Yojson.Safe.t
val var_of_yojson : Yojson.Safe.t -> var Ppx_deriving_yojson_runtime.error_or
val pp_var :
  Ppx_deriving_runtime.Format.formatter -> var -> Ppx_deriving_runtime.unit
val show_var : var -> Ppx_deriving_runtime.string
type sconst = FStar_Const.sconst
val sconst_to_yojson : sconst -> Yojson.Safe.t
val sconst_of_yojson :
  Yojson.Safe.t -> sconst Ppx_deriving_yojson_runtime.error_or
val pp_sconst :
  Ppx_deriving_runtime.Format.formatter ->
  sconst -> Ppx_deriving_runtime.unit
val show_sconst : sconst -> Ppx_deriving_runtime.string
type pragma =
    SetOptions of Prims.string
  | ResetOptions of Prims.string FStar_Pervasives_Native.option
  | PushOptions of Prims.string FStar_Pervasives_Native.option
  | PopOptions
  | RestartSolver
  | LightOff
val pragma_to_yojson : pragma -> Yojson.Safe.t
val pragma_of_yojson :
  Yojson.Safe.t -> pragma Ppx_deriving_yojson_runtime.error_or
val pp_pragma :
  Ppx_deriving_runtime.Format.formatter ->
  pragma -> Ppx_deriving_runtime.unit
val show_pragma : pragma -> Ppx_deriving_runtime.string
val uu___is_SetOptions : pragma -> Prims.bool
val __proj__SetOptions__item___0 : pragma -> Prims.string
val uu___is_ResetOptions : pragma -> Prims.bool
val __proj__ResetOptions__item___0 :
  pragma -> Prims.string FStar_Pervasives_Native.option
val uu___is_PushOptions : pragma -> Prims.bool
val __proj__PushOptions__item___0 :
  pragma -> Prims.string FStar_Pervasives_Native.option
val uu___is_PopOptions : pragma -> Prims.bool
val uu___is_RestartSolver : pragma -> Prims.bool
val uu___is_LightOff : pragma -> Prims.bool
type 'a memo = 'a FStar_Pervasives_Native.option FStar_ST.ref
val memo_to_yojson : ('a -> Yojson.Safe.t) -> 'a memo -> Yojson.Safe.t
val memo_of_yojson :
  (Yojson.Safe.t -> 'a Ppx_deriving_yojson_runtime.error_or) ->
  Yojson.Safe.t -> 'a memo Ppx_deriving_yojson_runtime.error_or
val pp_memo :
  (Ppx_deriving_runtime.Format.formatter -> 'a -> Ppx_deriving_runtime.unit) ->
  Ppx_deriving_runtime.Format.formatter ->
  'a memo -> Ppx_deriving_runtime.unit
val show_memo :
  (Ppx_deriving_runtime.Format.formatter -> 'a -> Ppx_deriving_runtime.unit) ->
  'a memo -> Ppx_deriving_runtime.string
type emb_typ =
    ET_abstract
  | ET_fun of (emb_typ * emb_typ)
  | ET_app of (Prims.string * emb_typ Prims.list)
val uu___is_ET_abstract : emb_typ -> Prims.bool
val uu___is_ET_fun : emb_typ -> Prims.bool
val __proj__ET_fun__item___0 : emb_typ -> emb_typ * emb_typ
val uu___is_ET_app : emb_typ -> Prims.bool
val __proj__ET_app__item___0 : emb_typ -> Prims.string * emb_typ Prims.list
type version = { major : Prims.int; minor : Prims.int; }
val version_to_yojson : version -> Yojson.Safe.t
val version_of_yojson :
  Yojson.Safe.t -> version Ppx_deriving_yojson_runtime.error_or
val pp_version :
  Ppx_deriving_runtime.Format.formatter ->
  version -> Ppx_deriving_runtime.unit
val show_version : version -> Ppx_deriving_runtime.string
val __proj__Mkversion__item__major : version -> Prims.int
val __proj__Mkversion__item__minor : version -> Prims.int
type universe =
    U_zero
  | U_succ of universe
  | U_max of universe Prims.list
  | U_bvar of Prims.int
  | U_name of FStar_Ident.ident
  | U_unif of
      (universe FStar_Pervasives_Native.option FStar_Unionfind.p_uvar *
       version)
  | U_unknown
val universe_to_yojson : universe -> Yojson.Safe.t
val universe_of_yojson :
  Yojson.Safe.t -> universe Ppx_deriving_yojson_runtime.error_or
val pp_universe :
  Ppx_deriving_runtime.Format.formatter ->
  universe -> Ppx_deriving_runtime.unit
val show_universe : universe -> Ppx_deriving_runtime.string
val uu___is_U_zero : universe -> Prims.bool
val uu___is_U_succ : universe -> Prims.bool
val __proj__U_succ__item___0 : universe -> universe
val uu___is_U_max : universe -> Prims.bool
val __proj__U_max__item___0 : universe -> universe Prims.list
val uu___is_U_bvar : universe -> Prims.bool
val __proj__U_bvar__item___0 : universe -> Prims.int
val uu___is_U_name : universe -> Prims.bool
val __proj__U_name__item___0 : universe -> FStar_Ident.ident
val uu___is_U_unif : universe -> Prims.bool
val __proj__U_unif__item___0 :
  universe ->
  universe FStar_Pervasives_Native.option FStar_Unionfind.p_uvar * version
val uu___is_U_unknown : universe -> Prims.bool
type univ_name = FStar_Ident.ident
val univ_name_to_yojson : univ_name -> Yojson.Safe.t
val univ_name_of_yojson :
  Yojson.Safe.t -> univ_name Ppx_deriving_yojson_runtime.error_or
val pp_univ_name :
  Ppx_deriving_runtime.Format.formatter ->
  univ_name -> Ppx_deriving_runtime.unit
val show_univ_name : univ_name -> Ppx_deriving_runtime.string
type universe_uvar =
    universe FStar_Pervasives_Native.option FStar_Unionfind.p_uvar * version
val universe_uvar_to_yojson : universe_uvar -> Yojson.Safe.t
val universe_uvar_of_yojson :
  Yojson.Safe.t -> universe_uvar Ppx_deriving_yojson_runtime.error_or
val pp_universe_uvar :
  Ppx_deriving_runtime.Format.formatter ->
  universe_uvar -> Ppx_deriving_runtime.unit
val show_universe_uvar : universe_uvar -> Ppx_deriving_runtime.string
type univ_names = univ_name Prims.list
val univ_names_to_yojson : univ_names -> Yojson.Safe.t
val univ_names_of_yojson :
  Yojson.Safe.t -> univ_names Ppx_deriving_yojson_runtime.error_or
val pp_univ_names :
  Ppx_deriving_runtime.Format.formatter ->
  univ_names -> Ppx_deriving_runtime.unit
val show_univ_names : univ_names -> Ppx_deriving_runtime.string
type universes = universe Prims.list
val universes_to_yojson : universes -> Yojson.Safe.t
val universes_of_yojson :
  Yojson.Safe.t -> universes Ppx_deriving_yojson_runtime.error_or
val pp_universes :
  Ppx_deriving_runtime.Format.formatter ->
  universes -> Ppx_deriving_runtime.unit
val show_universes : universes -> Ppx_deriving_runtime.string
type monad_name = FStar_Ident.lident
val monad_name_to_yojson : monad_name -> Yojson.Safe.t
val monad_name_of_yojson :
  Yojson.Safe.t -> monad_name Ppx_deriving_yojson_runtime.error_or
val pp_monad_name :
  Ppx_deriving_runtime.Format.formatter ->
  monad_name -> Ppx_deriving_runtime.unit
val show_monad_name : monad_name -> Ppx_deriving_runtime.string
type quote_kind = Quote_static | Quote_dynamic
val quote_kind_to_yojson : quote_kind -> Yojson.Safe.t
val quote_kind_of_yojson :
  Yojson.Safe.t -> quote_kind Ppx_deriving_yojson_runtime.error_or
val pp_quote_kind :
  Ppx_deriving_runtime.Format.formatter ->
  quote_kind -> Ppx_deriving_runtime.unit
val show_quote_kind : quote_kind -> Ppx_deriving_runtime.string
val uu___is_Quote_static : quote_kind -> Prims.bool
val uu___is_Quote_dynamic : quote_kind -> Prims.bool
type maybe_set_use_range = NoUseRange | SomeUseRange of FStar_Range.range
val maybe_set_use_range_to_yojson : maybe_set_use_range -> Yojson.Safe.t
val maybe_set_use_range_of_yojson :
  Yojson.Safe.t -> maybe_set_use_range Ppx_deriving_yojson_runtime.error_or
val pp_maybe_set_use_range :
  Ppx_deriving_runtime.Format.formatter ->
  maybe_set_use_range -> Ppx_deriving_runtime.unit
val show_maybe_set_use_range :
  maybe_set_use_range -> Ppx_deriving_runtime.string
val uu___is_NoUseRange : maybe_set_use_range -> Prims.bool
val uu___is_SomeUseRange : maybe_set_use_range -> Prims.bool
val __proj__SomeUseRange__item___0 : maybe_set_use_range -> FStar_Range.range
type delta_depth =
    Delta_constant_at_level of Prims.int
  | Delta_equational_at_level of Prims.int
  | Delta_abstract of delta_depth
val delta_depth_to_yojson : delta_depth -> Yojson.Safe.t
val delta_depth_of_yojson :
  Yojson.Safe.t -> delta_depth Ppx_deriving_yojson_runtime.error_or
val pp_delta_depth :
  Ppx_deriving_runtime.Format.formatter ->
  delta_depth -> Ppx_deriving_runtime.unit
val show_delta_depth : delta_depth -> Ppx_deriving_runtime.string
val uu___is_Delta_constant_at_level : delta_depth -> Prims.bool
val __proj__Delta_constant_at_level__item___0 : delta_depth -> Prims.int
val uu___is_Delta_equational_at_level : delta_depth -> Prims.bool
val __proj__Delta_equational_at_level__item___0 : delta_depth -> Prims.int
val uu___is_Delta_abstract : delta_depth -> Prims.bool
val __proj__Delta_abstract__item___0 : delta_depth -> delta_depth
type should_check_uvar = Allow_unresolved | Allow_untyped | Strict
val should_check_uvar_to_yojson : should_check_uvar -> Yojson.Safe.t
val should_check_uvar_of_yojson :
  Yojson.Safe.t -> should_check_uvar Ppx_deriving_yojson_runtime.error_or
val _ :
  Yojson.Safe.t -> should_check_uvar Ppx_deriving_yojson_runtime.error_or
val pp_should_check_uvar :
  Ppx_deriving_runtime.Format.formatter ->
  should_check_uvar -> Ppx_deriving_runtime.unit
val show_should_check_uvar : should_check_uvar -> Ppx_deriving_runtime.string
val uu___is_Allow_unresolved : should_check_uvar -> Prims.bool
val uu___is_Allow_untyped : should_check_uvar -> Prims.bool
val uu___is_Strict : should_check_uvar -> Prims.bool
type term' =
    Tm_bvar of bv
  | Tm_name of bv
  | Tm_fvar of fv
  | Tm_uinst of (term' syntax * universes)
  | Tm_constant of sconst
  | Tm_type of universe
  | Tm_abs of
      ((bv * arg_qualifier FStar_Pervasives_Native.option) Prims.list *
       term' syntax * residual_comp FStar_Pervasives_Native.option)
  | Tm_arrow of
      ((bv * arg_qualifier FStar_Pervasives_Native.option) Prims.list *
       comp' syntax)
  | Tm_refine of (bv * term' syntax)
  | Tm_app of
      (term' syntax *
       (term' syntax * arg_qualifier FStar_Pervasives_Native.option)
       Prims.list)
  | Tm_match of
      (term' syntax *
       (pat' withinfo_t * term' syntax FStar_Pervasives_Native.option *
        term' syntax)
       Prims.list)
  | Tm_ascribed of
      (term' syntax *
       ((term' syntax, comp' syntax) FStar_Util.either *
        term' syntax FStar_Pervasives_Native.option) *
       FStar_Ident.lident FStar_Pervasives_Native.option)
  | Tm_let of ((Prims.bool * letbinding Prims.list) * term' syntax)
  | Tm_uvar of
      (ctx_uvar * (subst_elt Prims.list Prims.list * maybe_set_use_range))
  | Tm_delayed of
      ((term' syntax *
        (subst_elt Prims.list Prims.list * maybe_set_use_range)) *
       term' syntax memo)
  | Tm_meta of (term' syntax * metadata)
  | Tm_lazy of lazyinfo
  | Tm_quoted of (term' syntax * quoteinfo)
  | Tm_unknown
and ctx_uvar = {
  ctx_uvar_head :
    term' syntax FStar_Pervasives_Native.option FStar_Unionfind.p_uvar *
    version;
  ctx_uvar_gamma : binding Prims.list;
  ctx_uvar_binders :
    (bv * arg_qualifier FStar_Pervasives_Native.option) Prims.list;
  ctx_uvar_typ : term' syntax;
  ctx_uvar_reason : Prims.string;
  ctx_uvar_should_check : should_check_uvar;
  ctx_uvar_range : FStar_Range.range;
  ctx_uvar_meta :
    (FStar_Dyn.dyn * term' syntax) FStar_Pervasives_Native.option;
}
and pat' =
    Pat_constant of sconst
  | Pat_cons of (fv * (pat' withinfo_t * Prims.bool) Prims.list)
  | Pat_var of bv
  | Pat_wild of bv
  | Pat_dot_term of (bv * term' syntax)
and letbinding = {
  lbname : (bv, fv) FStar_Util.either;
  lbunivs : univ_name Prims.list;
  lbtyp : term' syntax;
  lbeff : FStar_Ident.lident;
  lbdef : term' syntax;
  lbattrs : term' syntax Prims.list;
  lbpos : FStar_Range.range;
}
and quoteinfo = {
  qkind : quote_kind;
  antiquotes : (bv * term' syntax) Prims.list;
}
and comp_typ = {
  comp_univs : universes;
  effect_name : FStar_Ident.lident;
  result_typ : term' syntax;
  effect_args :
    (term' syntax * arg_qualifier FStar_Pervasives_Native.option) Prims.list;
  flags : cflag Prims.list;
}
and comp' =
    Total of (term' syntax * universe FStar_Pervasives_Native.option)
  | GTotal of (term' syntax * universe FStar_Pervasives_Native.option)
  | Comp of comp_typ
and cflag =
    TOTAL
  | MLEFFECT
  | LEMMA
  | RETURN
  | PARTIAL_RETURN
  | SOMETRIVIAL
  | TRIVIAL_POSTCONDITION
  | SHOULD_NOT_INLINE
  | CPS
  | DECREASES of term' syntax
and metadata =
    Meta_pattern of
      (term' syntax Prims.list *
       (term' syntax * arg_qualifier FStar_Pervasives_Native.option)
       Prims.list Prims.list)
  | Meta_named of FStar_Ident.lident
  | Meta_labeled of (Prims.string * FStar_Range.range * Prims.bool)
  | Meta_desugared of meta_source_info
  | Meta_monadic of (monad_name * term' syntax)
  | Meta_monadic_lift of (monad_name * monad_name * term' syntax)
and meta_source_info = Sequence | Primop | Masked_effect | Meta_smt_pat
and fv_qual =
    Data_ctor
  | Record_projector of (FStar_Ident.lident * FStar_Ident.ident)
  | Record_ctor of (FStar_Ident.lident * FStar_Ident.ident Prims.list)
and subst_elt =
    DB of (Prims.int * bv)
  | NM of (bv * Prims.int)
  | NT of (bv * term' syntax)
  | UN of (Prims.int * universe)
  | UD of (univ_name * Prims.int)
and 'a syntax = { n : 'a; pos : FStar_Range.range; vars : free_vars memo; }
and bv = {
  ppname : FStar_Ident.ident;
  index : Prims.int;
  sort : term' syntax;
}
and fv = {
  fv_name : var;
  fv_delta : delta_depth;
  fv_qual : fv_qual FStar_Pervasives_Native.option;
}
and free_vars = {
  free_names : bv Prims.list;
  free_uvars : ctx_uvar Prims.list;
  free_univs : universe_uvar Prims.list;
  free_univ_names : univ_name Prims.list;
}
and residual_comp = {
  residual_effect : FStar_Ident.lident;
  residual_typ : term' syntax FStar_Pervasives_Native.option;
  residual_flags : cflag Prims.list;
}
and lazyinfo = {
  blob : FStar_Dyn.dyn;
  lkind : lazy_kind;
  ltyp : term' syntax;
  rng : FStar_Range.range;
}
and lazy_kind =
    BadLazy
  | Lazy_bv
  | Lazy_binder
  | Lazy_optionstate
  | Lazy_fvar
  | Lazy_comp
  | Lazy_env
  | Lazy_proofstate
  | Lazy_goal
  | Lazy_sigelt
  | Lazy_uvar
  | Lazy_embedding of (emb_typ * term' syntax FStar_Common.thunk)
and binding =
    Binding_var of bv
  | Binding_lid of
      (FStar_Ident.lident * (univ_name Prims.list * term' syntax))
  | Binding_univ of univ_name
and arg_qualifier = Implicit of Prims.bool | Meta of term' syntax | Equality
val uu___is_Tm_bvar : term' -> Prims.bool
val __proj__Tm_bvar__item___0 : term' -> bv
val uu___is_Tm_name : term' -> Prims.bool
val __proj__Tm_name__item___0 : term' -> bv
val uu___is_Tm_fvar : term' -> Prims.bool
val __proj__Tm_fvar__item___0 : term' -> fv
val uu___is_Tm_uinst : term' -> Prims.bool
val __proj__Tm_uinst__item___0 : term' -> term' syntax * universes
val uu___is_Tm_constant : term' -> Prims.bool
val __proj__Tm_constant__item___0 : term' -> sconst
val uu___is_Tm_type : term' -> Prims.bool
val __proj__Tm_type__item___0 : term' -> universe
val uu___is_Tm_abs : term' -> Prims.bool
val __proj__Tm_abs__item___0 :
  term' ->
  (bv * arg_qualifier FStar_Pervasives_Native.option) Prims.list *
  term' syntax * residual_comp FStar_Pervasives_Native.option
val uu___is_Tm_arrow : term' -> Prims.bool
val __proj__Tm_arrow__item___0 :
  term' ->
  (bv * arg_qualifier FStar_Pervasives_Native.option) Prims.list *
  comp' syntax
val uu___is_Tm_refine : term' -> Prims.bool
val __proj__Tm_refine__item___0 : term' -> bv * term' syntax
val uu___is_Tm_app : term' -> Prims.bool
val __proj__Tm_app__item___0 :
  term' ->
  term' syntax *
  (term' syntax * arg_qualifier FStar_Pervasives_Native.option) Prims.list
val uu___is_Tm_match : term' -> Prims.bool
val __proj__Tm_match__item___0 :
  term' ->
  term' syntax *
  (pat' withinfo_t * term' syntax FStar_Pervasives_Native.option *
   term' syntax)
  Prims.list
val uu___is_Tm_ascribed : term' -> Prims.bool
val __proj__Tm_ascribed__item___0 :
  term' ->
  term' syntax *
  ((term' syntax, comp' syntax) FStar_Util.either *
   term' syntax FStar_Pervasives_Native.option) *
  FStar_Ident.lident FStar_Pervasives_Native.option
val uu___is_Tm_let : term' -> Prims.bool
val __proj__Tm_let__item___0 :
  term' -> (Prims.bool * letbinding Prims.list) * term' syntax
val uu___is_Tm_uvar : term' -> Prims.bool
val __proj__Tm_uvar__item___0 :
  term' -> ctx_uvar * (subst_elt Prims.list Prims.list * maybe_set_use_range)
val uu___is_Tm_delayed : term' -> Prims.bool
val __proj__Tm_delayed__item___0 :
  term' ->
  (term' syntax * (subst_elt Prims.list Prims.list * maybe_set_use_range)) *
  term' syntax memo
val uu___is_Tm_meta : term' -> Prims.bool
val __proj__Tm_meta__item___0 : term' -> term' syntax * metadata
val uu___is_Tm_lazy : term' -> Prims.bool
val __proj__Tm_lazy__item___0 : term' -> lazyinfo
val uu___is_Tm_quoted : term' -> Prims.bool
val __proj__Tm_quoted__item___0 : term' -> term' syntax * quoteinfo
val uu___is_Tm_unknown : term' -> Prims.bool
val __proj__Mkctx_uvar__item__ctx_uvar_head :
  ctx_uvar ->
  term' syntax FStar_Pervasives_Native.option FStar_Unionfind.p_uvar *
  version
val __proj__Mkctx_uvar__item__ctx_uvar_gamma : ctx_uvar -> binding Prims.list
val __proj__Mkctx_uvar__item__ctx_uvar_binders :
  ctx_uvar -> (bv * arg_qualifier FStar_Pervasives_Native.option) Prims.list
val __proj__Mkctx_uvar__item__ctx_uvar_typ : ctx_uvar -> term' syntax
val __proj__Mkctx_uvar__item__ctx_uvar_reason : ctx_uvar -> Prims.string
val __proj__Mkctx_uvar__item__ctx_uvar_should_check :
  ctx_uvar -> should_check_uvar
val __proj__Mkctx_uvar__item__ctx_uvar_range : ctx_uvar -> FStar_Range.range
val __proj__Mkctx_uvar__item__ctx_uvar_meta :
  ctx_uvar -> (FStar_Dyn.dyn * term' syntax) FStar_Pervasives_Native.option
val uu___is_Pat_constant : pat' -> Prims.bool
val __proj__Pat_constant__item___0 : pat' -> sconst
val uu___is_Pat_cons : pat' -> Prims.bool
val __proj__Pat_cons__item___0 :
  pat' -> fv * (pat' withinfo_t * Prims.bool) Prims.list
val uu___is_Pat_var : pat' -> Prims.bool
val __proj__Pat_var__item___0 : pat' -> bv
val uu___is_Pat_wild : pat' -> Prims.bool
val __proj__Pat_wild__item___0 : pat' -> bv
val uu___is_Pat_dot_term : pat' -> Prims.bool
val __proj__Pat_dot_term__item___0 : pat' -> bv * term' syntax
val __proj__Mkletbinding__item__lbname :
  letbinding -> (bv, fv) FStar_Util.either
val __proj__Mkletbinding__item__lbunivs : letbinding -> univ_name Prims.list
val __proj__Mkletbinding__item__lbtyp : letbinding -> term' syntax
val __proj__Mkletbinding__item__lbeff : letbinding -> FStar_Ident.lident
val __proj__Mkletbinding__item__lbdef : letbinding -> term' syntax
val __proj__Mkletbinding__item__lbattrs :
  letbinding -> term' syntax Prims.list
val __proj__Mkletbinding__item__lbpos : letbinding -> FStar_Range.range
val __proj__Mkquoteinfo__item__qkind : quoteinfo -> quote_kind
val __proj__Mkquoteinfo__item__antiquotes :
  quoteinfo -> (bv * term' syntax) Prims.list
val __proj__Mkcomp_typ__item__comp_univs : comp_typ -> universes
val __proj__Mkcomp_typ__item__effect_name : comp_typ -> FStar_Ident.lident
val __proj__Mkcomp_typ__item__result_typ : comp_typ -> term' syntax
val __proj__Mkcomp_typ__item__effect_args :
  comp_typ ->
  (term' syntax * arg_qualifier FStar_Pervasives_Native.option) Prims.list
val __proj__Mkcomp_typ__item__flags : comp_typ -> cflag Prims.list
val uu___is_Total : comp' -> Prims.bool
val __proj__Total__item___0 :
  comp' -> term' syntax * universe FStar_Pervasives_Native.option
val uu___is_GTotal : comp' -> Prims.bool
val __proj__GTotal__item___0 :
  comp' -> term' syntax * universe FStar_Pervasives_Native.option
val uu___is_Comp : comp' -> Prims.bool
val __proj__Comp__item___0 : comp' -> comp_typ
val uu___is_TOTAL : cflag -> Prims.bool
val uu___is_MLEFFECT : cflag -> Prims.bool
val uu___is_LEMMA : cflag -> Prims.bool
val uu___is_RETURN : cflag -> Prims.bool
val uu___is_PARTIAL_RETURN : cflag -> Prims.bool
val uu___is_SOMETRIVIAL : cflag -> Prims.bool
val uu___is_TRIVIAL_POSTCONDITION : cflag -> Prims.bool
val uu___is_SHOULD_NOT_INLINE : cflag -> Prims.bool
val uu___is_CPS : cflag -> Prims.bool
val uu___is_DECREASES : cflag -> Prims.bool
val __proj__DECREASES__item___0 : cflag -> term' syntax
val uu___is_Meta_pattern : metadata -> Prims.bool
val __proj__Meta_pattern__item___0 :
  metadata ->
  term' syntax Prims.list *
  (term' syntax * arg_qualifier FStar_Pervasives_Native.option) Prims.list
  Prims.list
val uu___is_Meta_named : metadata -> Prims.bool
val __proj__Meta_named__item___0 : metadata -> FStar_Ident.lident
val uu___is_Meta_labeled : metadata -> Prims.bool
val __proj__Meta_labeled__item___0 :
  metadata -> Prims.string * FStar_Range.range * Prims.bool
val uu___is_Meta_desugared : metadata -> Prims.bool
val __proj__Meta_desugared__item___0 : metadata -> meta_source_info
val uu___is_Meta_monadic : metadata -> Prims.bool
val __proj__Meta_monadic__item___0 : metadata -> monad_name * term' syntax
val uu___is_Meta_monadic_lift : metadata -> Prims.bool
val __proj__Meta_monadic_lift__item___0 :
  metadata -> monad_name * monad_name * term' syntax
val uu___is_Sequence : meta_source_info -> Prims.bool
val uu___is_Primop : meta_source_info -> Prims.bool
val uu___is_Masked_effect : meta_source_info -> Prims.bool
val uu___is_Meta_smt_pat : meta_source_info -> Prims.bool
val uu___is_Data_ctor : fv_qual -> Prims.bool
val uu___is_Record_projector : fv_qual -> Prims.bool
val __proj__Record_projector__item___0 :
  fv_qual -> FStar_Ident.lident * FStar_Ident.ident
val uu___is_Record_ctor : fv_qual -> Prims.bool
val __proj__Record_ctor__item___0 :
  fv_qual -> FStar_Ident.lident * FStar_Ident.ident Prims.list
val uu___is_DB : subst_elt -> Prims.bool
val __proj__DB__item___0 : subst_elt -> Prims.int * bv
val uu___is_NM : subst_elt -> Prims.bool
val __proj__NM__item___0 : subst_elt -> bv * Prims.int
val uu___is_NT : subst_elt -> Prims.bool
val __proj__NT__item___0 : subst_elt -> bv * term' syntax
val uu___is_UN : subst_elt -> Prims.bool
val __proj__UN__item___0 : subst_elt -> Prims.int * universe
val uu___is_UD : subst_elt -> Prims.bool
val __proj__UD__item___0 : subst_elt -> univ_name * Prims.int
val __proj__Mksyntax__item__n : 'a syntax -> 'a
val __proj__Mksyntax__item__pos : 'a syntax -> FStar_Range.range
val __proj__Mksyntax__item__vars : 'a syntax -> free_vars memo
val __proj__Mkbv__item__ppname : bv -> FStar_Ident.ident
val __proj__Mkbv__item__index : bv -> Prims.int
val __proj__Mkbv__item__sort : bv -> term' syntax
val __proj__Mkfv__item__fv_name : fv -> var
val __proj__Mkfv__item__fv_delta : fv -> delta_depth
val __proj__Mkfv__item__fv_qual :
  fv -> fv_qual FStar_Pervasives_Native.option
val __proj__Mkfree_vars__item__free_names : free_vars -> bv Prims.list
val __proj__Mkfree_vars__item__free_uvars : free_vars -> ctx_uvar Prims.list
val __proj__Mkfree_vars__item__free_univs :
  free_vars -> universe_uvar Prims.list
val __proj__Mkfree_vars__item__free_univ_names :
  free_vars -> univ_name Prims.list
val __proj__Mkresidual_comp__item__residual_effect :
  residual_comp -> FStar_Ident.lident
val __proj__Mkresidual_comp__item__residual_typ :
  residual_comp -> term' syntax FStar_Pervasives_Native.option
val __proj__Mkresidual_comp__item__residual_flags :
  residual_comp -> cflag Prims.list
val __proj__Mklazyinfo__item__blob : lazyinfo -> FStar_Dyn.dyn
val __proj__Mklazyinfo__item__lkind : lazyinfo -> lazy_kind
val __proj__Mklazyinfo__item__ltyp : lazyinfo -> term' syntax
val __proj__Mklazyinfo__item__rng : lazyinfo -> FStar_Range.range
val uu___is_BadLazy : lazy_kind -> Prims.bool
val uu___is_Lazy_bv : lazy_kind -> Prims.bool
val uu___is_Lazy_binder : lazy_kind -> Prims.bool
val uu___is_Lazy_optionstate : lazy_kind -> Prims.bool
val uu___is_Lazy_fvar : lazy_kind -> Prims.bool
val uu___is_Lazy_comp : lazy_kind -> Prims.bool
val uu___is_Lazy_env : lazy_kind -> Prims.bool
val uu___is_Lazy_proofstate : lazy_kind -> Prims.bool
val uu___is_Lazy_goal : lazy_kind -> Prims.bool
val uu___is_Lazy_sigelt : lazy_kind -> Prims.bool
val uu___is_Lazy_uvar : lazy_kind -> Prims.bool
val uu___is_Lazy_embedding : lazy_kind -> Prims.bool
val __proj__Lazy_embedding__item___0 :
  lazy_kind -> emb_typ * term' syntax FStar_Common.thunk
val uu___is_Binding_var : binding -> Prims.bool
val __proj__Binding_var__item___0 : binding -> bv
val uu___is_Binding_lid : binding -> Prims.bool
val __proj__Binding_lid__item___0 :
  binding -> FStar_Ident.lident * (univ_name Prims.list * term' syntax)
val uu___is_Binding_univ : binding -> Prims.bool
val __proj__Binding_univ__item___0 : binding -> univ_name
val uu___is_Implicit : arg_qualifier -> Prims.bool
val __proj__Implicit__item___0 : arg_qualifier -> Prims.bool
val uu___is_Meta : arg_qualifier -> Prims.bool
val __proj__Meta__item___0 : arg_qualifier -> term' syntax
val uu___is_Equality : arg_qualifier -> Prims.bool
type subst_ts = subst_elt Prims.list Prims.list * maybe_set_use_range
type ctx_uvar_and_subst =
    ctx_uvar * (subst_elt Prims.list Prims.list * maybe_set_use_range)
type term = term' syntax
type uvar =
    term' syntax FStar_Pervasives_Native.option FStar_Unionfind.p_uvar *
    version
type uvars = ctx_uvar FStar_Util.set
type pat = pat' withinfo_t
type branch =
    pat' withinfo_t * term' syntax FStar_Pervasives_Native.option *
    term' syntax
type comp = comp' syntax
type ascription =
    (term' syntax, comp' syntax) FStar_Util.either *
    term' syntax FStar_Pervasives_Native.option
type antiquotations = (bv * term' syntax) Prims.list
type typ = term' syntax
type aqual = arg_qualifier FStar_Pervasives_Native.option
type arg = term' syntax * arg_qualifier FStar_Pervasives_Native.option
type args =
    (term' syntax * arg_qualifier FStar_Pervasives_Native.option) Prims.list
type binder = bv * arg_qualifier FStar_Pervasives_Native.option
type binders = (bv * arg_qualifier FStar_Pervasives_Native.option) Prims.list
type lbname = (bv, fv) FStar_Util.either
type letbindings = Prims.bool * letbinding Prims.list
type freenames = bv FStar_Util.set
type attribute = term' syntax
type tscheme = univ_name Prims.list * term' syntax
type gamma = binding Prims.list
type lcomp = {
  eff_name : FStar_Ident.lident;
  res_typ : typ;
  cflags : cflag Prims.list;
  comp_thunk : (Prims.unit -> comp, comp) FStar_Util.either FStar_ST.ref;
}
val __proj__Mklcomp__item__eff_name : lcomp -> FStar_Ident.lident
val __proj__Mklcomp__item__res_typ : lcomp -> typ
val __proj__Mklcomp__item__cflags : lcomp -> cflag Prims.list
val __proj__Mklcomp__item__comp_thunk :
  lcomp -> (Prims.unit -> comp, comp) FStar_Util.either FStar_ST.ref
val lazy_chooser :
  (lazy_kind -> lazyinfo -> term) FStar_Pervasives_Native.option FStar_ST.ref
val mk_lcomp :
  FStar_Ident.lident ->
  typ -> cflag Prims.list -> (Prims.unit -> comp) -> lcomp
val lcomp_comp : lcomp -> comp
type freenames_l = bv Prims.list
type formula = typ
type formulae = typ Prims.list
type qualifier =
    Assumption
  | New
  | Private
  | Unfold_for_unification_and_vcgen
  | Visible_default
  | Irreducible
  | Abstract
  | Inline_for_extraction
  | NoExtract
  | Noeq
  | Unopteq
  | TotalEffect
  | Logic
  | Reifiable
  | Reflectable of FStar_Ident.lident
  | Discriminator of FStar_Ident.lident
  | Projector of (FStar_Ident.lident * FStar_Ident.ident)
  | RecordType of
      (FStar_Ident.ident Prims.list * FStar_Ident.ident Prims.list)
  | RecordConstructor of
      (FStar_Ident.ident Prims.list * FStar_Ident.ident Prims.list)
  | Action of FStar_Ident.lident
  | ExceptionConstructor
  | HasMaskedEffect
  | Effect
  | OnlyName
val uu___is_Assumption : qualifier -> Prims.bool
val uu___is_New : qualifier -> Prims.bool
val uu___is_Private : qualifier -> Prims.bool
val uu___is_Unfold_for_unification_and_vcgen : qualifier -> Prims.bool
val uu___is_Visible_default : qualifier -> Prims.bool
val uu___is_Irreducible : qualifier -> Prims.bool
val uu___is_Abstract : qualifier -> Prims.bool
val uu___is_Inline_for_extraction : qualifier -> Prims.bool
val uu___is_NoExtract : qualifier -> Prims.bool
val uu___is_Noeq : qualifier -> Prims.bool
val uu___is_Unopteq : qualifier -> Prims.bool
val uu___is_TotalEffect : qualifier -> Prims.bool
val uu___is_Logic : qualifier -> Prims.bool
val uu___is_Reifiable : qualifier -> Prims.bool
val uu___is_Reflectable : qualifier -> Prims.bool
val __proj__Reflectable__item___0 : qualifier -> FStar_Ident.lident
val uu___is_Discriminator : qualifier -> Prims.bool
val __proj__Discriminator__item___0 : qualifier -> FStar_Ident.lident
val uu___is_Projector : qualifier -> Prims.bool
val __proj__Projector__item___0 :
  qualifier -> FStar_Ident.lident * FStar_Ident.ident
val uu___is_RecordType : qualifier -> Prims.bool
val __proj__RecordType__item___0 :
  qualifier -> FStar_Ident.ident Prims.list * FStar_Ident.ident Prims.list
val uu___is_RecordConstructor : qualifier -> Prims.bool
val __proj__RecordConstructor__item___0 :
  qualifier -> FStar_Ident.ident Prims.list * FStar_Ident.ident Prims.list
val uu___is_Action : qualifier -> Prims.bool
val __proj__Action__item___0 : qualifier -> FStar_Ident.lident
val uu___is_ExceptionConstructor : qualifier -> Prims.bool
val uu___is_HasMaskedEffect : qualifier -> Prims.bool
val uu___is_Effect : qualifier -> Prims.bool
val uu___is_OnlyName : qualifier -> Prims.bool
type tycon = FStar_Ident.lident * binders * typ
type monad_abbrev = {
  mabbrev : FStar_Ident.lident;
  parms : binders;
  def : typ;
}
val __proj__Mkmonad_abbrev__item__mabbrev :
  monad_abbrev -> FStar_Ident.lident
val __proj__Mkmonad_abbrev__item__parms : monad_abbrev -> binders
val __proj__Mkmonad_abbrev__item__def : monad_abbrev -> typ
type sub_eff = {
  source : FStar_Ident.lident;
  target : FStar_Ident.lident;
  lift_wp : tscheme FStar_Pervasives_Native.option;
  lift : tscheme FStar_Pervasives_Native.option;
}
val __proj__Mksub_eff__item__source : sub_eff -> FStar_Ident.lident
val __proj__Mksub_eff__item__target : sub_eff -> FStar_Ident.lident
val __proj__Mksub_eff__item__lift_wp :
  sub_eff -> tscheme FStar_Pervasives_Native.option
val __proj__Mksub_eff__item__lift :
  sub_eff -> tscheme FStar_Pervasives_Native.option
type action = {
  action_name : FStar_Ident.lident;
  action_unqualified_name : FStar_Ident.ident;
  action_univs : univ_names;
  action_params : binders;
  action_defn : term;
  action_typ : typ;
}
val __proj__Mkaction__item__action_name : action -> FStar_Ident.lident
val __proj__Mkaction__item__action_unqualified_name :
  action -> FStar_Ident.ident
val __proj__Mkaction__item__action_univs : action -> univ_names
val __proj__Mkaction__item__action_params : action -> binders
val __proj__Mkaction__item__action_defn : action -> term
val __proj__Mkaction__item__action_typ : action -> typ
type eff_decl = {
  cattributes : cflag Prims.list;
  mname : FStar_Ident.lident;
  univs : univ_names;
  binders : binders;
  signature : tscheme;
  ret_wp : tscheme;
  bind_wp : tscheme;
  if_then_else : tscheme;
  ite_wp : tscheme;
  stronger : tscheme;
  close_wp : tscheme;
  trivial : tscheme;
  repr : tscheme;
  return_repr : tscheme;
  bind_repr : tscheme;
  actions : action Prims.list;
  eff_attrs : attribute Prims.list;
}
val __proj__Mkeff_decl__item__cattributes : eff_decl -> cflag Prims.list
val __proj__Mkeff_decl__item__mname : eff_decl -> FStar_Ident.lident
val __proj__Mkeff_decl__item__univs : eff_decl -> univ_names
val __proj__Mkeff_decl__item__binders : eff_decl -> binders
val __proj__Mkeff_decl__item__signature : eff_decl -> tscheme
val __proj__Mkeff_decl__item__ret_wp : eff_decl -> tscheme
val __proj__Mkeff_decl__item__bind_wp : eff_decl -> tscheme
val __proj__Mkeff_decl__item__if_then_else : eff_decl -> tscheme
val __proj__Mkeff_decl__item__ite_wp : eff_decl -> tscheme
val __proj__Mkeff_decl__item__stronger : eff_decl -> tscheme
val __proj__Mkeff_decl__item__close_wp : eff_decl -> tscheme
val __proj__Mkeff_decl__item__trivial : eff_decl -> tscheme
val __proj__Mkeff_decl__item__repr : eff_decl -> tscheme
val __proj__Mkeff_decl__item__return_repr : eff_decl -> tscheme
val __proj__Mkeff_decl__item__bind_repr : eff_decl -> tscheme
val __proj__Mkeff_decl__item__actions : eff_decl -> action Prims.list
val __proj__Mkeff_decl__item__eff_attrs : eff_decl -> attribute Prims.list
type sig_metadata = {
  sigmeta_active : Prims.bool;
  sigmeta_fact_db_ids : Prims.string Prims.list;
}
val __proj__Mksig_metadata__item__sigmeta_active : sig_metadata -> Prims.bool
val __proj__Mksig_metadata__item__sigmeta_fact_db_ids :
  sig_metadata -> Prims.string Prims.list
type sigelt' =
    Sig_inductive_typ of
      (FStar_Ident.lident * univ_names * binders * typ *
       FStar_Ident.lident Prims.list * FStar_Ident.lident Prims.list)
  | Sig_bundle of (sigelt Prims.list * FStar_Ident.lident Prims.list)
  | Sig_datacon of
      (FStar_Ident.lident * univ_names * typ * FStar_Ident.lident *
       Prims.int * FStar_Ident.lident Prims.list)
  | Sig_declare_typ of (FStar_Ident.lident * univ_names * typ)
  | Sig_let of (letbindings * FStar_Ident.lident Prims.list)
  | Sig_main of term
  | Sig_assume of (FStar_Ident.lident * univ_names * formula)
  | Sig_new_effect of eff_decl
  | Sig_new_effect_for_free of eff_decl
  | Sig_sub_effect of sub_eff
  | Sig_effect_abbrev of
      (FStar_Ident.lident * univ_names * binders * comp * cflag Prims.list)
  | Sig_pragma of pragma
  | Sig_splice of (FStar_Ident.lident Prims.list * term)
and sigelt = {
  sigel : sigelt';
  sigrng : FStar_Range.range;
  sigquals : qualifier Prims.list;
  sigmeta : sig_metadata;
  sigattrs : attribute Prims.list;
  sigopts : FStar_Options.optionstate FStar_Pervasives_Native.option;
}
val uu___is_Sig_inductive_typ : sigelt' -> Prims.bool
val __proj__Sig_inductive_typ__item___0 :
  sigelt' ->
  FStar_Ident.lident * univ_names * binders * typ *
  FStar_Ident.lident Prims.list * FStar_Ident.lident Prims.list
val uu___is_Sig_bundle : sigelt' -> Prims.bool
val __proj__Sig_bundle__item___0 :
  sigelt' -> sigelt Prims.list * FStar_Ident.lident Prims.list
val uu___is_Sig_datacon : sigelt' -> Prims.bool
val __proj__Sig_datacon__item___0 :
  sigelt' ->
  FStar_Ident.lident * univ_names * typ * FStar_Ident.lident * Prims.int *
  FStar_Ident.lident Prims.list
val uu___is_Sig_declare_typ : sigelt' -> Prims.bool
val __proj__Sig_declare_typ__item___0 :
  sigelt' -> FStar_Ident.lident * univ_names * typ
val uu___is_Sig_let : sigelt' -> Prims.bool
val __proj__Sig_let__item___0 :
  sigelt' -> letbindings * FStar_Ident.lident Prims.list
val uu___is_Sig_main : sigelt' -> Prims.bool
val __proj__Sig_main__item___0 : sigelt' -> term
val uu___is_Sig_assume : sigelt' -> Prims.bool
val __proj__Sig_assume__item___0 :
  sigelt' -> FStar_Ident.lident * univ_names * formula
val uu___is_Sig_new_effect : sigelt' -> Prims.bool
val __proj__Sig_new_effect__item___0 : sigelt' -> eff_decl
val uu___is_Sig_new_effect_for_free : sigelt' -> Prims.bool
val __proj__Sig_new_effect_for_free__item___0 : sigelt' -> eff_decl
val uu___is_Sig_sub_effect : sigelt' -> Prims.bool
val __proj__Sig_sub_effect__item___0 : sigelt' -> sub_eff
val uu___is_Sig_effect_abbrev : sigelt' -> Prims.bool
val __proj__Sig_effect_abbrev__item___0 :
  sigelt' ->
  FStar_Ident.lident * univ_names * binders * comp * cflag Prims.list
val uu___is_Sig_pragma : sigelt' -> Prims.bool
val __proj__Sig_pragma__item___0 : sigelt' -> pragma
val uu___is_Sig_splice : sigelt' -> Prims.bool
val __proj__Sig_splice__item___0 :
  sigelt' -> FStar_Ident.lident Prims.list * term
val __proj__Mksigelt__item__sigel : sigelt -> sigelt'
val __proj__Mksigelt__item__sigrng : sigelt -> FStar_Range.range
val __proj__Mksigelt__item__sigquals : sigelt -> qualifier Prims.list
val __proj__Mksigelt__item__sigmeta : sigelt -> sig_metadata
val __proj__Mksigelt__item__sigattrs : sigelt -> attribute Prims.list
val __proj__Mksigelt__item__sigopts :
  sigelt -> FStar_Options.optionstate FStar_Pervasives_Native.option
type sigelts = sigelt Prims.list
type modul = {
  name : FStar_Ident.lident;
  declarations : sigelts;
  exports : sigelts;
  is_interface : Prims.bool;
}
val __proj__Mkmodul__item__name : modul -> FStar_Ident.lident
val __proj__Mkmodul__item__declarations : modul -> sigelts
val __proj__Mkmodul__item__exports : modul -> sigelts
val __proj__Mkmodul__item__is_interface : modul -> Prims.bool
val mod_name : modul -> FStar_Ident.lident
type path = Prims.string Prims.list
type subst_t = subst_elt Prims.list
type 'a mk_t_a =
    Prims.unit FStar_Pervasives_Native.option ->
    FStar_Range.range -> 'a syntax
type mk_t = term' mk_t_a
val contains_reflectable : qualifier Prims.list -> Prims.bool
val withinfo : 'a -> FStar_Range.range -> 'a withinfo_t
val withsort : 'a -> 'a withinfo_t
val bv_eq : bv -> bv -> Prims.bool
val order_bv : bv -> bv -> Prims.int
val order_ident : FStar_Ident.ident -> FStar_Ident.ident -> Prims.int
val order_fv : FStar_Ident.lident -> FStar_Ident.lident -> Prims.int
val range_of_lbname : lbname -> FStar_Range.range
val range_of_bv : bv -> FStar_Range.range
val set_range_of_bv : bv -> FStar_Range.range -> bv
val on_antiquoted : (term -> term) -> quoteinfo -> quoteinfo
val lookup_aq : bv -> antiquotations -> term FStar_Pervasives_Native.option
val syn :
  'Auu____8277 ->
  'Auu____8278 ->
  ('Auu____8278 -> 'Auu____8277 -> 'Auu____8279) -> 'Auu____8279
val mk_fvs :
  Prims.unit -> 'Auu____8310 FStar_Pervasives_Native.option FStar_ST.ref
val mk_uvs :
  Prims.unit -> 'Auu____8327 FStar_Pervasives_Native.option FStar_ST.ref
val new_bv_set : Prims.unit -> bv FStar_Util.set
val new_id_set : Prims.unit -> FStar_Ident.ident FStar_Util.set
val new_fv_set : Prims.unit -> FStar_Ident.lident FStar_Util.set
val order_univ_name : univ_name -> univ_name -> Prims.int
val new_universe_names_set : Prims.unit -> univ_name FStar_Util.set
val eq_binding : binding -> binding -> Prims.bool
val no_names : freenames
val no_fvars : FStar_Ident.lident FStar_Util.set
val no_universe_names : univ_name FStar_Util.set
val freenames_of_list : bv Prims.list -> freenames
val list_of_freenames : freenames -> bv Prims.list
val mk : 'a -> 'a mk_t_a
val bv_to_tm : bv -> term
val bv_to_name : bv -> term
val binders_to_names : binders -> term Prims.list
val mk_Tm_app : term -> args -> mk_t
val mk_Tm_uinst : term -> universes -> term
val extend_app_n : term -> args -> mk_t
val extend_app : term -> arg -> mk_t
val mk_Tm_delayed : term * subst_ts -> FStar_Range.range -> term
val mk_Total' : typ -> universe FStar_Pervasives_Native.option -> comp
val mk_GTotal' : typ -> universe FStar_Pervasives_Native.option -> comp
val mk_Total : typ -> comp
val mk_GTotal : typ -> comp
val mk_Comp : comp_typ -> comp
val mk_lb :
  lbname * univ_name Prims.list * FStar_Ident.lident * typ * term *
  attribute Prims.list * FStar_Range.range -> letbinding
val mk_Tac : typ -> comp
val default_sigmeta : sig_metadata
val mk_sigelt : sigelt' -> sigelt
val mk_subst : subst_t -> subst_t
val extend_subst : subst_elt -> subst_elt Prims.list -> subst_t
val argpos : arg -> FStar_Range.range
val tun : term
val teff : term
val is_teff : term -> Prims.bool
val is_type : term -> Prims.bool
val null_id : FStar_Ident.ident
val null_bv : term -> bv
val mk_binder : bv -> binder
val null_binder : term -> binder
val imp_tag : arg_qualifier
val iarg : term -> arg
val as_arg : term -> arg
val is_null_bv : bv -> Prims.bool
val is_null_binder : binder -> Prims.bool
val is_top_level : letbinding Prims.list -> Prims.bool
val freenames_of_binders : binders -> freenames
val binders_of_list : bv Prims.list -> binders
val binders_of_freenames : freenames -> binders
val is_implicit : aqual -> Prims.bool
val as_implicit : Prims.bool -> aqual
val pat_bvs : pat -> bv Prims.list
val range_of_ropt :
  FStar_Range.range FStar_Pervasives_Native.option -> FStar_Range.range
val gen_bv :
  Prims.string ->
  FStar_Range.range FStar_Pervasives_Native.option -> typ -> bv
val new_bv : FStar_Range.range FStar_Pervasives_Native.option -> typ -> bv
val freshen_bv : bv -> bv
val freshen_binder : binder -> binder
val new_univ_name :
  FStar_Range.range FStar_Pervasives_Native.option -> univ_name
val mkbv : FStar_Ident.ident -> Prims.int -> term' syntax -> bv
val lbname_eq :
  (bv, FStar_Ident.lident) FStar_Util.either ->
  (bv, FStar_Ident.lident) FStar_Util.either -> Prims.bool
val fv_eq : fv -> fv -> Prims.bool
val fv_eq_lid : fv -> FStar_Ident.lident -> Prims.bool
val set_bv_range : bv -> FStar_Range.range -> bv
val lid_as_fv :
  FStar_Ident.lident ->
  delta_depth -> fv_qual FStar_Pervasives_Native.option -> fv
val fv_to_tm : fv -> term
val fvar :
  FStar_Ident.lident ->
  delta_depth -> fv_qual FStar_Pervasives_Native.option -> term
val lid_of_fv : fv -> FStar_Ident.lid
val range_of_fv : fv -> FStar_Range.range
val set_range_of_fv : fv -> FStar_Range.range -> fv
val has_simple_attribute : term Prims.list -> Prims.string -> Prims.bool
val eq_pat : pat -> pat -> Prims.bool
val delta_constant : delta_depth
val delta_equational : delta_depth
val fvconst : FStar_Ident.lident -> fv
val tconst : FStar_Ident.lident -> term
val tabbrev : FStar_Ident.lident -> term
val tdataconstr : FStar_Ident.lident -> term
val t_unit : term
val t_bool : term
val t_int : term
val t_string : term
val t_exn : term
val t_real : term
val t_float : term
val t_char : term
val t_range : term
val t_term : term
val t_term_view : term
val t_order : term
val t_decls : term
val t_binder : term
val t_binders : term
val t_bv : term
val t_fv : term
val t_norm_step : term
val t_tac_of : term -> term -> term
val t_tactic_of : term -> term
val t_tactic_unit : term
val t_list_of : term -> term
val t_option_of : term -> term
val t_tuple2_of : term -> term -> term
val t_either_of : term -> term -> term
val unit_const : term
